;(function(document, $) {
    "use strict";

    var PREVIEW_URL = '/mnt/overlay/wcm/core/content/sites/diffresources.html';

    var previewButton;
    var ui;

    $(document).on("foundation-contentloaded", function(e){
		if (!previewButton) {
			previewButton = new PreviewButton();
			previewButton.initialize();
		}

		 ui = $(window).adaptTo("foundation-ui");
	});

	var PreviewButton = new Class({

		$previewButton: null,

		initialize: function () {
			var self = this;
			self.$previewButton = document.querySelector(".smartling-submission-preview");

            if (!self.$previewButton) {
                return;
            }

			Coral.commons.ready(self.$previewButton, function() {

				self.$previewButton.on('click', function(event){
				    var nodes = [];
                    $('tr.is-selected[data-node-path]').each(function(i, item) {
                        nodes.push(item.dataset);
                    });
                    if (nodes.length == 1) {
                        var data = nodes[0];
                        if (data.configType === 'CONTENT' && data.state && data.targetPath !== null) {
                            window.open(PREVIEW_URL + data.sourcePath + '?item=' + data.targetPath + '&sideBySide');
                        } else {
                            ui.alert('Not available', 'Preview mode is not available');
                        }
                    } else {
				        ui.alert('Not available', 'Preview mode is not available');
				    }
				});

			})

			$('#table_custom_sort').on('coral-table:change', function(event) {
                var eventDetails = event.detail;

                if (event.detail.selection.length == 1) {
                    self.$previewButton.classList.remove("foundation-collection-action-hidden");
                    if (event.detail.selection[0].dataset.configType == 'CONTENT') {
                        self.$previewButton.disabled = false;
                    } else {
                        self.$previewButton.disabled = true;
                    }
                } else {
                    self.$previewButton.classList.add("foundation-collection-action-hidden");
                }
            });
		}
	});
})(document, Granite.$);