(function ($) {

    function updateLastMessage(data) {
        var lastElement = data[data.length - 1];
        $('.submission__log-hidden .timestamp').text(lastElement.timestamp);
        $('.submission__log-hidden .hashCode').text(lastElement.messageHashCode);
    }

    function removeNoLogsMessage() {
        $('.submission__log_absent').remove();
    }

    function errorData(data) {
        var errorsArray = [];
        var submissionEntry = {
            error: true,
            timestamp: +$('.submission__log-hidden .timestamp').text(),
            message: "Upload of new logs failed! Status: " + data.status + ". Message: " + data.statusText
        };
        errorsArray.push(submissionEntry);

        return errorsArray;
    }


    function update() {
        var timeStamp = +$('.submission__log-hidden .timestamp').text();
        var hashCode = +$('.submission__log-hidden .hashCode').text();

        $.ajax({
            type: 'GET',
            url: '/services/smartling/submission/logs/new',
            data: {
                'timestamp': timeStamp,
                'hashCode': hashCode
            },
            success: function (data) {
                if (data.length == 0) {
                    return;
                }
                append(data);
                updateLastMessage(data);
                removeNoLogsMessage();
            },
            error: function (data) {
                append(errorData(data));
                removeNoLogsMessage();
            }
        });
    }

    function buildListItem(submissionLog) {
        return '<li class="submission__log-entry ' + (submissionLog.error ? 'submission__log-entry-error' : '') + '">' +
            '<span class="submission__log-entry-timestamp">' + getDate(submissionLog.timestamp) + '</span>' + submissionLog.message +
            '</li>';
    }

    function append(submissionLogs) {
        var listHead = $('.submission__log');
        for (var i = 0; i < submissionLogs.length; i++) {
            listHead.append(buildListItem(submissionLogs[i]))
        }
    }

    function getDate(dateTime) {
        var dateObject = new Date(dateTime);
        return "[" + dateObject.toUTCString() + "] ";
    }

    (function run() {
        setInterval(update, 5000);
    }());

})
(jQuery);
