(function ($document, author, SMARTLING) {
    function handleComponentLocking(editable) {
        var foundationUi = $(window).adaptTo('foundation-ui');

        foundationUi.wait(editable.overlay.dom);
        $.ajax({
            type: 'POST',
            url: '/services/smartling/components/locked',
            data: {
                pagePath: author.page.path,
                elementPath: editable.path
            }
        }).done(function (data) {
            editable.updateSmartlingLockState(data.locked);

            if (data.message) {
                foundationUi.alert('Info', data.message, 'notice');
            }
        }).fail(function () {
            foundationUi.alert('Error', 'Failed to lock / unlock component', 'error');
        }).always(function () {
            editable.setInactive();
            editable.setUnselected();
            foundationUi.clearWait();
        });

        // Close toolbar
        return true;
    }

    function handleActionRegistration(action) {
        author.EditorFrame.editableToolbar.registerAction(action.name, action);
    }

    SMARTLING.ui = SMARTLING.ui || {};
    SMARTLING.ui.touch = SMARTLING.ui.touch || {};
    SMARTLING.ui.touch.Toolbar = SMARTLING.ui.touch.Toolbar || {};

    SMARTLING.ui.touch.Toolbar.lockComponentAction = {
        name: 'SMARTLING_LOCK_COMPONENT',
        icon: 'coral-Icon--lockOn',
        text: 'Lock Component',
        condition: function (editable) {
            return !editable.getSmartlingLockState();
        },
        handler: handleComponentLocking,
        isNonMulti: true,

        register: function () {
            handleActionRegistration(this);
        }
    };

    SMARTLING.ui.touch.Toolbar.unlockComponentAction = {
        name: 'SMARTLING_UNLOCK_COMPONENT',
        icon: 'coral-Icon--lockOff',
        text: 'Unlock Component',
        condition: function (editable) {
            return editable.getSmartlingLockState();
        },
        handler: handleComponentLocking,
        isNonMulti: true,

        register: function () {
            handleActionRegistration(this);
        }
    };
})($(document), Granite.author, window.SMARTLING = window.SMARTLING || {});

