;(function (document, $, smartlingApi) {
    "use strict";

    var $dialog;
    var progressBar; // save a reference for later use

    /**
     * Method to retrieve the path to current content resource (this implementation only works for editor.html).
     *
     * @returns {String} path of the current resource, e.g. /content/we-retail/language-masters/en
     */
    smartlingApi.getContentPath = function () {
        return $('.foundation-content-path').data('foundationContentPath').replace('.html','');
    };

    $(document).ready(function () {
        $dialog = $('#classic-smartling-job-dialog');
        var $sidekickPanel = $('#smartling-sidekick-panel');

        //In case, when translation dialog or sidekick panle are not presented on the page, loading of progress bare shoudn't be executed.
        if ($dialog.length == 0 || $sidekickPanel.length == 0) {
            console.warn('Translation dialog or sidekick panel are not available.');
            return;
        }

        progressBar = new smartlingApi.ProgressBar($sidekickPanel);

        // load current status right away
        progressBar.load(smartlingApi.getContentPath());
    });


})(document, Granite.$, window.SmartlingApi = window.SmartlingApi || {}); // TODO: rename to smartlingTouch or something