;(function (document, $, smartlingApi) {
    "use strict";

    var progressBar; // save a reference for later use

    var $dialog;
    var $addToJobForm;
    var $createJobForm;

    smartlingApi.getContentPath = function () {
        var $items = $('.foundation-collection').find(".foundation-selections-item");
        if($items.length === 1) {
            // for simplicity, only return result in case of single selection
            return $items.data("foundationCollectionItemId");
        }
    };

    $(document).ready(function () {
        $dialog = $('#classic-smartling-job-dialog');
        $addToJobForm = $dialog.find('#classic-add-to-job-form');
        $createJobForm = $dialog.find('#classic-create-job-form');

        progressBar = new smartlingApi.ProgressBar($("#smartling-sidekick-panel"));

        //Handler for item selection event
        $(document).on("foundation-selections-change", function (e) {
            var $collection = $(e.target);

            var $items = $collection.find(".foundation-selections-item");

            if ($items.length === 0) {
                progressBar.clear('Select an item to display its status.');
            } else if ($items.length === 1) {
                var path = smartlingApi.getContentPath();
                if (!!path && smartlingApi.isSelectionSupported()) {
                    progressBar.load(path);

                    //Dynamically updating of source translation path parameter
                    $addToJobForm.find('input[name=paths]').val(path);
                    $createJobForm.find('input[name=paths]').val(path);

                    //Dynamically load available target languages
                    $.ajax({
                        url: '/services/smartling/locales?path=' + smartlingApi.getContentPath()
                    }).done(function(data) {
                        $(document).trigger('languageSelector:resetLocales', {locales: data});
                    });
                } else {
                    progressBar.clear('Smartling does not support this asset type.');
                }
            } else {
                progressBar.clear('Submissions status is not available for multiple selection.');
            }
        });
    });

})(document, Granite.$, window.SmartlingApi = window.SmartlingApi || {});